<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
            "http://www.w3.org/TR/html4/loose.dtd">
<html>
<!--
/*
 * ============================================================================
 * Licensed Materials - Property of IBM
 * Project  Zero
 *
 * (C) Copyright IBM Corp. 2007  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 * ============================================================================
 */
-->
<head>
<META http-equiv="Content-Type" content="text/html; charset=UTF-8">
</head>
<body bgcolor="#BFFFE4" style="color: #a46262">

<p>
Implementa la especificación Jazz Open Services para Lifecycle Collaboration. Como se
describe en el <a href="https://jazz.net/pub/index.jsp">sitio de la comunidad Jazz</a>:
"La iniciativa Open Services para Lifecycle Collaboration está dirigida a simplificar la
colaboración en todo el ciclo de vida de la entrega de software. Su objetivo es permitir
a los equipos de trabajo utilizar distintas herramientas y compartir recursos de ciclo
de vida en la entrega de software, tanto si las herramientas son de IBM como de otros
fabricantes, proyectos de código abierto o desarrollo interno, y hacerlo de modo que sea
abierto y no propietario, y que anime a todos los miembros del sector a participar en
ella". .
</p>

<p>
Aquí se documentan detalles importantes acerca de esta especificación que aún no se han
detallado explícitamente hasta ahora. Agradecemos a James Branigan la información que nos
ha proporcionado.
</p>


<h2>Almacenamiento de recursos simples</h2>

<p>
  zero.openservices implementa el
  <a href="https://jazz.net/open-services/services/simple-storage.jsp">
    Simple Resource Storage Core Service</a>.
</p>

<h3>Cache-Conditionals</h3>

<p>
Según las especificaciones (nota 6) GET y HEAD devuelven 412 incluso en casos de ETag
"obsoletos" y por tanto difiere del comportamiento de PUT y DELETE (ver a
continuación) que deben devolver 409. Se devuelve 412 en caso de fallo de
If-Modified-Since e If-Unmodified-Since.
</p>

<p>
Según las especificaciones (nota 7), el servidor devuelve 409 para los casos PUT/DELETE
en que If-Match no pueda emparejar el ETag de la entidad actual para el recurso y en
que If-None-Match empareja la entidad actual (generalmente con un ETag comodín). No
obstante, incluso en las solicitudes de ETags If-{None}-Match , se <em>devuelve</em> 412
si no existe una versión no archivada del recurso. Se devuelve 412 en caso de fallo de
If-Modified-Since e If-Unmodified-Since.
Se trata de una interpretación holística de la especificación HTTP y en cierto modo
distinta de la que dice la sección 14.
</p>

<p>
Si el cliente especifica If-Match junto con If-None-Match o If-[Un]Modified-Since,
prevalece el código de retorno 409.
</p>

<h3>Resource Revision Histories</h3>

<p>
  zero.openservices implementa
        the <a href="http://jazz.net/open-services/services/revisions.jsp">
        Resource Revision Histories Additional Service
      </a>.
</p>

<h4>Recursos suprimidos</h4>

<p>
Queremos clarificar el comportamiento del servicio de revisión con respecto a los
recursos suprimidos.
</p>

<p>
El servicio <em>nunca</em> suprime físicamente un recurso o una revisión concreta
de un recurso, porque se considera que mantener un seguimiento de auditoría es un
requisito importante. Cuando un cliente realiza una operación DELETE, se crea una nueva
revisión del recurso y se marca internamente como suprimido.
</p>

<p>
En el caso de los SRs, este enfoque permite al servicio distinguir entre el caso de un
recursos que se está creando y posteriormente suprimiendo, del caso de un recurso que no
se había creado antes. En el primer caso, el servicio devuelve un 410 (Ido) a una
solicitud GET; en el segundo caso, el servicio devuelve un 404 (No encontrado).
</p>

<p>
Con respecto a la provisión de un canal de información que contenga el histórico de un
recurso, las revisiones suprimidas no tendrán un puntero sucesor. Cuando un cliente
busca en la entrada de revisión el recurso suprimido, verá un elemento "content" vacío (la
única forma en que los clientes pueden distinguir entre una revisión suprimida y un
recurso de cero bytes es realizando un GET).
</p>

<p>
En el caso de un URI específico de revisión, un GET siempre tendrá éxito (devolverá 200),
con independencia de si la versión se ha suprimido o no.
</p>

<h2>Especificación de paquete y versión</h2>

<p>
Los números de versión son números de release svn:
en "docs/versions.txt" se proporciona más información acerca del contenido de un
release concreto. <ol>
    <li><em>r21979</em>: proporciona la implementación inicial del Simple Resource Storage Core Service.
  </ol>
</p>



<h2>Documentación relacionada</h2>

<p>
Más información sobre Jazz Open Services:
  <ul>
    <li>
      <a href="https://jazz.net/open-services/services/index.jsp">Open Services
	for Lifecycle Collaboration
      </a>
    <li>
      <a href="https://jazz.net/open-services/services/simple-storage.jsp">
	Simple Resource Storage Core Service
      </a>
    <li>
      <a href="http://jazz.net/open-services/services/revisions.jsp">
        Resource Revision Histories Additional Service
      </a>
  </ul>
</p>

</body>
</html>
