<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
            "http://www.w3.org/TR/html4/loose.dtd">
<html>
<!--
/*
 * ============================================================================
 * Licensed Materials - Property of IBM
 * Project  Zero
 *
 * (C) Copyright IBM Corp. 2007  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 * ============================================================================
 */
-->
<head>
<META http-equiv="Content-Type" content="text/html; charset=UTF-8">
</head>
<body bgcolor="#BFFFE4" style="color: #a46262">

<p>
  Implémente les Services Jazz Open pour la spécification de Collaboration pendant le cycle de vie.
  Comme décrit sur le <a href="https://jazz.net/pub/index.jsp">Site de la communauté Jazz </a>: "Les Services Open pour l'initiative de collaboration pendant le cycle de vie vise à simplifier la collaboration pendant le cycle de vie de livraison de logiciels. Son objectif est de permettre aux équipe d'utiliser des outils hétérogènes et de partager les ressources du cycle de vie en fournissant des logiciels, que les outils proviennent d'IBM, d'autres fournisseurs, de projets open source, ou de développement en interne, et de le faire de manière ouverte et non brevetée afin d'encourager la participation de tous les membres du secteur.".
</p>

<p>
  Nous présentons ici des détails impotrants sur la spécification qui n'est pas encore explicitement détaillée aux présentes.  Un grand merci à James Branigan pour nous avoir fourni ces informations.
</p>


<h2>Stockage de ressource simple</h2>

<p>
  zero.openservices met en oeuvre
  <a href="https://jazz.net/open-services/services/simple-storage.jsp">
    Le Service de Base de Stockage de Ressource Simple </a>.
</p>

<h3>Cache-Conditionals</h3>

<p>
  D'après les spécifications (note 6) GET et HEAD renvoient 412 même pour les cas ETag "périmés", et elles diffèrent ainsi du comportement de PUT et DELETE (voir ci-dessous) qui renverraient 409.  412 est renvoyé pour un échec de If-Modified-Since et de If-Unmodified-Since.
</p>

<p>
  Conformément à la spécification (note 7), le serveur renvoie 409 pour les cas PUT/DELETE dans lesquels
  If-Match ne correspond pas à l'ETag de l'entité actuelle pour la ressource, et dans lesquels If-None-Match ne correspond pas à l'entité actuelle (généralement avec un ETag à caractère générique).  Cependant, même pour les requêtes ETag If-{None}-Match, 412 <em>est</em> renvoyé si aucune version non archivée des ressources n'existe.  412 est renvoyé pour un échec de If-Modified-Since et de If-Unmodified-Since.
Il y a une interprétation holistique de la spécification HTTP, et elle est relativement différente de ce qu'affirme la section 14.
</p>

<p>
  Si le client spécifie If-Match avec (soit If-None-Match
  soit If-[Un]Modified-Since, le code retour 409 prévaut.
</p>

<h3>Historiques de révision des ressources</h3>

<p>
  zero.openservices implémente
        le <a href="http://jazz.net/open-services/services/revisions.jsp">
        Service Supplémentaire des Historiques de Révision des Ressources </a>.
</p>

<h4>Ressources supprimées</h4>

<p>
Nous clarifions ici le comportement du service de révision en ce qui concerne les ressources supprimées.
</p>

<p>
  Le service ne supprime <em>jamais</em> physiquement une ressource ou une révision spécifique d'une ressource car le maintien d'une piste d'audit est considéré comme une exigence essentielle.  Lorsqu'un client effectue une opération DELETE, une nouvelle révision de la ressource est créée, et marquée en interne comme supprimée.
</p>

<p>
  En cas de spécification des exigences logicielles, cette approche permet les dinctions de service entre le cas d'une ressource créée puis supprimée et le cas d'une ressource qui n'a jamais été créée.  Dans le premier cas, le servoce renvoie un 410 (Parti) à une requête GET ; dans le deuxième cas le service renvoe un 404 (Introuvable).
</p>

<p>
  En ce qui concerne la fourniture d'un flux contenant l'historique d'une ressource, les révisions supprimées n'auront pas de pointeur suivant.  Lorsqu'un client regarde l'entrée de la révision de la ressource supprimée, il verra un élément de "contenu" vide.  (La seule manière dont les clients peuvent distinguer entre une révision supprimée et une ressource zéro octet est d'effectuer une commande GET.)
</p>

<p>
Dans le cas d'une URI spécifique à la révision, une commande GET réussira toujours (renvoyant un code 200), que la version ait été supprimée ou non.
</p>

<h2>Spécification du package et de la version</h2>

<p>
  Les numéros de version sont des numéros d'édition svn : "docs/versions.txt" qui fournissent plus d'informations sur le contenu d'une édition spécifique.
  <ol>
    <li><em>r21979</em> : fournit l'implémentation initiale du Service de Base de Stockage des Ressources Simples.
  </ol>
</p>



<h2>Documentation connexe</h2>

<p>
Plus d'informations sur les Services Jazz Open :
  <ul>
    <li>
      <a href="https://jazz.net/open-services/services/index.jsp">Services ouverts pour une collaboration pendant le cycle de vie</a>
    <li>
      <a href="https://jazz.net/open-services/services/simple-storage.jsp">
	Service de Base de Stockage de Ressources Simples</a>
    <li>
      <a href="http://jazz.net/open-services/services/revisions.jsp">
        Service Supplémentaire d'Historiques de Révision des Ressources</a>
  </ul>
</p>

</body>
</html>
